#include <stdio.h>
#include <stdlib.h>

#define New(Tp, N) ((Tp*)malloc(sizeof(Tp) * N))

void Solve(int N, __int128 h[], int ans[]);

int main() {
  int N, T, a;
  scanf("%d", &T);
  while (T--) {
    scanf("%d", &N);
    __int128* w = New(__int128, N);
    __int128* wb = New(__int128, N);
    int* ans = New(int, 2 * N + 3);
    for (int i = 0; i < N; i++) {
      scanf("%d", &a); wb[i] = w[i] = a;
    }
    Solve(N, wb, ans);

    typedef struct { __int128 a, b; } P;
    P* stk = New(P, 2 * N + 3);
    int top = 0, now = 0;
    __int128 cost = 0;

    for (int i = 0; i < 2 * N - 3; i++) {
      printf("%d%c", ans[i], " \n"[i == 2 * N - 4]);
    }
    for (int i = 0; i < 2 * N - 3; i++) {
      if (ans[i] >= 0) {
        if (now++ != ans[i]) {
          now = -1; break;
        }
        stk[top].a = w[ans[i]], stk[top].b = w[ans[i] + 1];
        top++;
      } else {
        stk[top].a = stk[top].b = -1;
        top++;
      }
      while (top >= 3) {
        P* fir = stk + top - 1;
        P* sec = stk + top - 2;
        P* trd = stk + top - 3;
        if (fir->a < 0 || sec->a < 0) break;
        cost += sec->a * sec->b * fir->b;
        trd->a = sec->a;
        trd->b = fir->b;
        top -= 2;
      }
    }
    if (top != 1 || now == -1) {
      puts("Invalid expression tree");
    } else {
      long long thresh = 1000000000000000000;
      if (cost < thresh) printf("%lld\n", (long long)cost);
      else printf("%lld%018lld\n", (long long)(cost / thresh),
          (long long)(cost % thresh));
    }
    free(w), free(wb), free(ans), free(stk);
  }
}

#undef New
